﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Animation;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            NameScope.SetNameScope(this, new NameScope());

            Button testButton = new Button();

            testButton.Width    = 300;
            testButton.Height   = 100;
            testButton.FontSize = 24;
            testButton.Content  = "TEST";

            RegisterName("testButton", testButton);

            BooleanAnimationUsingKeyFrames booleanAnimation = new BooleanAnimationUsingKeyFrames();

            booleanAnimation.Duration = TimeSpan.FromSeconds(4);

            booleanAnimation.KeyFrames.Add(new DiscreteBooleanKeyFrame(false, KeyTime.FromTimeSpan(TimeSpan.FromSeconds(0.0))));
            booleanAnimation.KeyFrames.Add(new DiscreteBooleanKeyFrame(true , KeyTime.FromTimeSpan(TimeSpan.FromSeconds(1.0))));
            booleanAnimation.KeyFrames.Add(new DiscreteBooleanKeyFrame(false, KeyTime.FromTimeSpan(TimeSpan.FromSeconds(2.0))));
            booleanAnimation.KeyFrames.Add(new DiscreteBooleanKeyFrame(true , KeyTime.FromTimeSpan(TimeSpan.FromSeconds(3.0))));
            booleanAnimation.KeyFrames.Add(new DiscreteBooleanKeyFrame(false, KeyTime.FromTimeSpan(TimeSpan.FromSeconds(3.5))));
            booleanAnimation.KeyFrames.Add(new DiscreteBooleanKeyFrame(true , KeyTime.FromTimeSpan(TimeSpan.FromSeconds(4.0))));

            Storyboard.SetTargetName(booleanAnimation, "testButton");
            Storyboard.SetTargetProperty(booleanAnimation, new PropertyPath(Button.IsEnabledProperty));

            Storyboard storyboard = new Storyboard();
 
            storyboard.Children.Add(booleanAnimation);

            testButton.Click += delegate(object sender, RoutedEventArgs e)
            {
                storyboard.Begin(this);
            };

            Content = testButton;
        }

        #endregion
    }
}